// -*- C++ -*-

/*  src/StringEnumeration.cpp  */


/*
 * Author: Philogelos A. <Philogelos@yahoo.com>
 * Maintainer: Philogelos A.
 * Keywords: C++, library, containers
 *
 * Copyright (C) 1998 Philogelos A.
 *
 * This file is part of Quercus Robusta.
 *
 * Quercus Robusta is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this software; see the file COPYING.LIB.  If not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */


/* $Id: StringEnumeration.cpp,v 1.3 1999/03/03 19:09:30 philogelos Exp $ */
#if !defined(_INLINE)
static char cvsid[] = "@(#)$Id: StringEnumeration.cpp,v 1.3 1999/03/03 19:09:30 philogelos Exp $";
static char debugFileId[] = __FILE__;
#endif


#include "defines.h"
#include "Char.hpp"
#include "UCSChar.hpp"
#include "Debug.hpp"
#include "OGuard.hpp"
#include "PGuard.hpp"
#include "LinkManager.hpp"
#include "UTF8Converter.hpp"
#include "KOI8RConverter.hpp"
#include "StringEnumeration.hpp"
#include "containers/FrozenValue.hpp"

StringEnumeration::StringEnumeration( String aString ) :
  core( aString )
{
  position = 0;
}

StringEnumeration::~StringEnumeration()
{}

boolean StringEnumeration::hasMoreElements()
{
  return ( position < core.length() );
}

Char *StringEnumeration::getNextCharFast()
{
  sure_( position < core.length() );
  current -> setUNICODE( core.getUNIChars()[ position++ ] );
  return current;
}

String  StringEnumeration::getString() const
{
  return core;
}

String  StringEnumeration::toString() const
{
  return Object::toString() + " on top of: " + core;
}

String  StringEnumeration::getClassName() const
{
  return "StringEnumeration";
}

#if defined(_INLINE)
#include "../src/Debug.ipp"
#endif

/* $Log: StringEnumeration.cpp,v $
 * Revision 1.3  1999/03/03 19:09:30  philogelos
 * Put sources under GNU Library License
 *
 * Revision 1.2  1999/02/28 15:57:16  philogelos
 * Tuned for inlines. ::getNextElement() rewritten to conform to the new interface
 *
 * Revision 1.1.1.1  1998/11/25 20:11:01  philogelos
 * Quercus Robusta
 *
 * Revision 1.3  1998/07/09 09:04:46  philogelos
 * custom new/delete added
 *
 * Revision 1.2  1998/07/07 14:30:00  philogelos
 * Memory leak in SUNWspro dynamic_cast fixed.
 *
 * Revision 1.1.1.1  1998/06/22 08:47:12  philogelos
 * First version under CVS
 *
 * Revision 1.1.1.1  1998/04/01 17:15:29  philogelos
 * first version under CVS
 * */
